# Utilisez une image de base avec Java
FROM openjdk:17

# Définissez le répertoire de travail
WORKDIR /app

# Copiez les fichiers build.gradle et settings.gradle pour optimiser le cache des dépendances
COPY build.gradle settings.gradle /app/

# Copiez le script gradlew pour optimiser le cache des dépendances
COPY gradlew /app/gradlew

# Copiez le dossier gradle pour optimiser le cache des dépendances
COPY gradle /app/gradle

# Téléchargez les dépendances (cette étape permet de mettre en cache les dépendances avant de copier tout le projet)
RUN ./gradlew --no-daemon build || true

# Copiez le reste du code source
COPY . /app

# Exposez le port sur lequel votre application Spring Boot fonctionne
EXPOSE 8080

# Spécifiez le profil Spring Boot
ENV SPRING_PROFILES_ACTIVE=minikube

# Commande pour démarrer votre application Spring Boot
CMD ["java", "-jar", "build/libs/demo-api-0.0.1-SNAPSHOT.jar"]

#  java -jar demo-api-0.0.1-SNAPSHOT.jar --spring.profiles.active=minikube
#  docker build -t nom-de-votre-image:tag -f DockerFileMinikube .
#  docker images
#  docker run -p 8080:8080 nom-de-votre-image:tag
#  trouver ou sont les images docker
#  docker info | findstr "Docker Root Dir"

# lancer avec chart helm
# docker stop
# minikube start
# minikube image load nom-de-votre-image:tag
# minikube image ls --format table
# kubectl create namespace mon-namespace
# helm install demo-api-chart .
# helm install demo-api-chart . --set image.repository=nom-de-votre-image,image.tag=tag
# helm install demo-api-chart . --set image.repository=nom-de-votre-image,image.tag=tag --namespace mon-namespace
# kubectl get pods
# kubectl get pods -n mon-namespace

# kubectl port-forward demo-api-chart-77fc77d885-8rqvz 8080:8080

# lancer sans chart helm
# kubectl run first-container --image=nom-de-votre-image:tag --image-pull-policy=Never --restart=Never
# kubectl port-forward first-container 8080:8080

# kubectl get pods
# kubectl port-forward first-container 8080:8080

# arrêter sans namespace
# kubectl get deployments
# kubectl delete deployment <nom-du-deploiement>
# helm list
# helm delete demo-api-chart

# arrêter avec namespace
# kubectl get deployments -n mon-namespace
# kubectl delete deployment <nom-du-deploiement> -n mon-namespace
# helm list -n mon-namespace
# helm delete demo-api-chart -n mon-namespace

# minikube stop
# minikube delete



